glibmm: Gio::DBus::Object Class Reference

glibmm 2.42.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::DBus::Object Class Reference

Object - Base type for D-Bus objects. More...

`#include <giomm/dbusobject.h>`

Inheritance diagram for Gio::DBus::Object:
[legend]

## Public Member Functions
virtual | ~Object ()
GDBusObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GDBusObject* | gobj () const
| Provides access to the underlying C GObject. More...
Glib::ustring | get_object_path () const
| Gets the object path for object. More...
std::vector< Glib::RefPtr < Gio::DBus::Interface > > | get_interfaces ()
| Gets the D-Bus interfaces associated with object. More...
std::vector< Glib::RefPtr < const Gio::DBus::Interface > > | get_interfaces () const
| Gets the D-Bus interfaces associated with object. More...
Glib::RefPtr < Gio::DBus::Interface > | get_interface (const Glib::ustring& interface_name)
| Gets the D-Bus interface with name interface_name associated with object, if any. More...
Glib::RefPtr< const Gio::DBus::Interface > | get_interface (const Glib::ustring& interface_name) const
| Gets the D-Bus interface with name interface_name associated with object, if any. More...
Glib::SignalProxy1< void, const Glib::RefPtr < Gio::DBus::Interface >& > | signal_interface_added ()
Glib::SignalProxy1< void, const Glib::RefPtr < Gio::DBus::Interface >& > | signal_interface_removed ()
virtual Glib::ustring | get_object_path_vfunc () const
virtual std::vector < Glib::RefPtr < Gio::DBus::Interface > > | get_interfaces_vfunc () const
virtual Glib::RefPtr < Gio::DBus::Interface > | get_interface_vfunc (const Glib::ustring& interface_name) const
Public Member Functions inherited from Glib::Interface
| Interface ()
| A Default constructor. More...
| Interface (const Glib::Interface_Class& interface_class)
| Called by constructors of derived classes. More...
| Interface (GObject* castitem)
| Called by constructors of derived classes. More...
virtual | ~Interface ()
GObject* | gobj ()
const GObject* | gobj () const
Public Member Functions inherited from Glib::ObjectBase
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...

## Static Public Member Functions
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Object ()
| You should derive from this class to use it. More...
virtual void | on_interface_added (const Glib::RefPtr< Gio::DBus::Interface >& iface)
| This is a default handler for the signal signal_interface_added(). More...
virtual void | on_interface_removed (const Glib::RefPtr< Gio::DBus::Interface >& iface)
| This is a default handler for the signal signal_interface_removed(). More...
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::DBus::Object > | wrap (GDBusObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

Object - Base type for D-Bus objects.

The Object type is the base type for D-Bus objects on both the service side (see ObjectSkeleton) and the client side (see ObjectProxy). It is essentially just a container of interfaces.

Since glibmm 2.34:

## Constructor & Destructor Documentation

Gio::DBus::Object::Object | ( |  | ) |
| protected

You should derive from this class to use it.

virtual Gio::DBus::Object::~Object | ( |  | ) |
| virtual

## Member Function Documentation

static void Gio::DBus::Object::add_interface | ( | GType | gtype_implementer | ) |
| static

Glib::RefPtr<Gio::DBus::Interface> Gio::DBus::Object::get_interface | ( | const Glib::ustring& | interface_name | ) |

Gets the D-Bus interface with name interface_name associated with object, if any.

Since glibmm 2.30:

Parameters

  interface_name | A D-Bus interface name.

Returns
  `0` if not found, otherwise a DBusInterface that must be freed with Glib::object_unref().

Glib::RefPtr<const Gio::DBus::Interface> Gio::DBus::Object::get_interface | ( | const Glib::ustring& | interface_name | ) | const

Gets the D-Bus interface with name interface_name associated with object, if any.

Since glibmm 2.30:

Parameters

  interface_name | A D-Bus interface name.

Returns
  `0` if not found, otherwise a DBusInterface that must be freed with Glib::object_unref().

virtual Glib::RefPtr<Gio::DBus::Interface> Gio::DBus::Object::get_interface_vfunc | ( | const Glib::ustring& | interface_name | ) | const
| virtual

std::vector< Glib::RefPtr<Gio::DBus::Interface> > Gio::DBus::Object::get_interfaces | ( |  | ) |

Gets the D-Bus interfaces associated with object.

Since glibmm 2.30:

Returns
  A list of DBusInterface instances. The returned list must be freed by Glib::list_free() after each element has been freed with Glib::object_unref().

std::vector< Glib::RefPtr<const Gio::DBus::Interface> > Gio::DBus::Object::get_interfaces | ( |  | ) | const

Gets the D-Bus interfaces associated with object.

Since glibmm 2.30:

Returns
  A list of DBusInterface instances. The returned list must be freed by Glib::list_free() after each element has been freed with Glib::object_unref().

virtual std::vector< Glib::RefPtr<Gio::DBus::Interface> > Gio::DBus::Object::get_interfaces_vfunc | ( |  | ) | const
| virtual

Glib::ustring Gio::DBus::Object::get_object_path | ( |  | ) | const

Gets the object path for object.

Since glibmm 2.30:

Returns
  A string owned by object. Do not free.

virtual Glib::ustring Gio::DBus::Object::get_object_path_vfunc | ( |  | ) | const
| virtual

static GType Gio::DBus::Object::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GDBusObject* Gio::DBus::Object::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GDBusObject* Gio::DBus::Object::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

virtual void Gio::DBus::Object::on_interface_added | ( | const Glib::RefPtr< Gio::DBus::Interface >& | iface | ) |
| protectedvirtual

This is a default handler for the signal signal_interface_added().

virtual void Gio::DBus::Object::on_interface_removed | ( | const Glib::RefPtr< Gio::DBus::Interface >& | iface | ) |
| protectedvirtual

This is a default handler for the signal signal_interface_removed().

Glib::SignalProxy1< void,const Glib::RefPtr<Gio::DBus::Interface>& > Gio::DBus::Object::signal_interface_added | ( |  | ) |

Slot Prototype:
  `void on_my_interface_added(const Glib::RefPtr<Gio::DBus::Interface>& iface)`

Emitted when interface is added to object.

Since glibmm 2.30:

Parameters

  interface | The DBusInterface that was added.

Glib::SignalProxy1< void,const Glib::RefPtr<Gio::DBus::Interface>& > Gio::DBus::Object::signal_interface_removed | ( |  | ) |

Slot Prototype:
  `void on_my_interface_removed(const Glib::RefPtr<Gio::DBus::Interface>& iface)`

Emitted when interface is removed from object.

Since glibmm 2.30:

Parameters

  interface | The DBusInterface that was removed.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::DBus::Object > wrap | ( | GDBusObject * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.